/* ***********************************************************
 * This file was automatically generated on 2022-07-26.      *
 *                                                           *
 * LabVIEW Bindings Version 2.1.31                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures ambient temperature with 0.5°C accuracy
	/// </summary>
	public class BrickletTemperature : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 216;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Temperature Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_TEMPERATURE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_I2C_MODE = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_I2C_MODE = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_TEMPERATURE = 8;

		private const int CALLBACK_TEMPERATURE_REACHED = 9;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';

		/// <summary>
		/// </summary>
		public const byte I2C_MODE_FAST = 0;

		/// <summary>
		/// </summary>
		public const byte I2C_MODE_SLOW = 1;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletTemperature.SetTemperatureCallbackPeriod"/>. The parameter is the
		///  temperature of the sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletTemperature.TemperatureCallback"/> callback is only triggered if the temperature has changed
		///  since the last triggering.
		/// </summary>
		public event TemperatureEventHandler TemperatureCallback;
		/// <summary>
		/// </summary>
		public delegate void TemperatureEventHandler(BrickletTemperature sender, short temperature);

		/// <summary>
		/// </summary>
		public event TemperatureEventHandler Temperature // for backward compatibility
		{
			add { TemperatureCallback += value; }
			remove { TemperatureCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletTemperature.SetTemperatureCallbackThreshold"/> is reached.
		///  The parameter is the temperature of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletTemperature.SetDebouncePeriod"/>.
		/// </summary>
		public event TemperatureReachedEventHandler TemperatureReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void TemperatureReachedEventHandler(BrickletTemperature sender, short temperature);

		/// <summary>
		/// </summary>
		public event TemperatureReachedEventHandler TemperatureReached // for backward compatibility
		{
			add { TemperatureReachedCallback += value; }
			remove { TemperatureReachedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletTemperature(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 1;

			callbackWrappers[CALLBACK_TEMPERATURE] = new CallbackWrapper(OnTemperatureCallback);
			callbackWrappers[CALLBACK_TEMPERATURE_REACHED] = new CallbackWrapper(OnTemperatureReachedCallback);


			responseExpected[FUNCTION_GET_TEMPERATURE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_I2C_MODE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_I2C_MODE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the temperature of the sensor.
		///  
		///  If you want to get the temperature periodically, it is recommended
		///  to use the <see cref="Tinkerforge.BrickletTemperature.TemperatureCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletTemperature.SetTemperatureCallbackPeriod"/>.
		/// </summary>
		public short GetTemperature()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_TEMPERATURE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.ShortFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletTemperature.TemperatureCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletTemperature.TemperatureCallback"/> callback is only triggered if the temperature has changed
		///  since the last triggering.
		/// </summary>
		public void SetTemperatureCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletTemperature.SetTemperatureCallbackPeriod"/>.
		/// </summary>
		public long GetTemperatureCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletTemperature.TemperatureReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the temperature is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the temperature is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the temperature is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the temperature is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetTemperatureCallbackThreshold(char option, short min, short max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletTemperature.SetTemperatureCallbackThreshold"/>.
		/// </summary>
		public void GetTemperatureCallbackThreshold(out char option, out short min, out short max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 13);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.ShortFrom(9, response);
			max = LEConverter.ShortFrom(11, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callback
		///  
		///  * <see cref="Tinkerforge.BrickletTemperature.TemperatureReachedCallback"/>
		///  
		///  is triggered, if the threshold
		///  
		///  * <see cref="Tinkerforge.BrickletTemperature.SetTemperatureCallbackThreshold"/>
		///  
		///  keeps being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletTemperature.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the I2C mode. Possible modes are:
		///  
		///  * 0: Fast (400kHz)
		///  * 1: Slow (100kHz)
		///  
		///  If you have problems with obvious outliers in the
		///  Temperature Bricklet measurements, they may be caused by EMI issues.
		///  In this case it may be helpful to lower the I2C speed.
		///  
		///  It is however not recommended to lower the I2C speed in applications where
		///  a high throughput needs to be achieved.
		///  
		///  .. versionadded:: 2.0.1$nbsp;(Plugin)
		/// </summary>
		public void SetI2CMode(byte mode)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_I2C_MODE);
			LEConverter.To((byte)mode, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the I2C mode as set by <see cref="Tinkerforge.BrickletTemperature.SetI2CMode"/>.
		///  
		///  .. versionadded:: 2.0.1$nbsp;(Plugin)
		/// </summary>
		public byte GetI2CMode()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_I2C_MODE);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnTemperatureCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			short temperature = LEConverter.ShortFrom(8, response);
			var handler = TemperatureCallback;

			if (handler != null)
			{
				handler(this, temperature);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnTemperatureReachedCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			short temperature = LEConverter.ShortFrom(8, response);
			var handler = TemperatureReachedCallback;

			if (handler != null)
			{
				handler(this, temperature);
			}
		}
	}
}
